;;########################################################################
;; regvis6.lsp
;; Visualization for OLS, Robust & Monotonic Regression ViSta model object
;; Copyright (c) 1995-6 by Carla M. Bann
;;########################################################################

(setf *rsq-plots* nil)


(defmeth var-list-proto :links ()
  (if (member self *rsq-plots*) *rsq-plots*))

(defmeth var-list-proto :linked (&optional (link nil set))
  (when set (setf *rsq-plots* (if link (cons self *rsq-plots*)
                                  (remove self *rsq-plots*)))
            (call-next-method link))
  (call-next-method))



; _______________________________________________________

(setf *obs-plots* nil)

(defmeth residual-plot-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth residual-plot-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))

(defmeth influence-plot-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth influence-plot-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))

(defmeth lsmt-plot-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth lsmt-plot-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))

(defmeth lin-reg-plot-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth lin-reg-plot-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))

(defmeth obs-list-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth obs-list-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))

(defmeth robust-plot-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth robust-plot-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))

(defmeth robust-reg-plot-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth robust-reg-plot-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))



; ___________________________________________________________________

(defproto added-var-plot-proto '(spreadplot-supervisor showing x)
  '() scatterplot-proto)

(defmeth added-var-plot-proto :spreadplot-supervisor (&optional (obj-id nil set)) 
  (when set (setf (slot-value 'spreadplot-supervisor) obj-id)) 
  (slot-value 'spreadplot-supervisor))

(defmeth added-var-plot-proto :showing (&optional (obj-id nil set)) 
  (when set (setf (slot-value 'showing) obj-id)) 
  (slot-value 'showing))

(defmeth added-var-plot-proto :x (&optional (value nil set)) 
  (when set (setf (slot-value 'x) value)) 
  (slot-value 'x))

(defmeth added-var-plot-proto :show-plot ()
  (send self :show-window)
  (send self :showing t))


(defmeth added-var-plot-proto :change-y-axis ()
  (send (send self :spreadplot-supervisor) :get-added-var self))

(defun added-var-plot (spreadplot-supervisor x y &rest args)
  (apply #'send added-var-plot-proto :new spreadplot-supervisor x y args))


(defmeth added-var-plot-proto :isnew
  (spreadplot-supervisor x y
     &rest args
     &key
     (title "Added Variables")
     (menu-title "AddVar")
     (scale 'nil)
     (show 't)
     showing) 
  (let* ((labels (send (send spreadplot-supervisor :model) :labels)))
  (send self :spreadplot-supervisor spreadplot-supervisor)
  (apply #'call-next-method 2 
         (append args `(:title ,title :menu-title ,menu-title
                        :show nil)))
  (send self :add-points x y :point-labels labels :draw 'nil)
  (send self :add-overlay (make-overlay3 self))
  (send self :adjust-to-data :draw 'nil)
  (if show (send self :show-window))))

(defmeth added-var-plot-proto :close ()
  (send (send self :spreadplot-supervisor) :close-dialog self))

(defmeth added-var-plot-proto :links ()
  (if (member self *obs-plots*) *obs-plots*))

(defmeth added-var-plot-proto :linked (&optional (link nil set))
  (when set (setf *obs-plots* (if link (cons self *obs-plots*)
                                  (remove self *obs-plots*)))
            (call-next-method link))
  (call-next-method))



(defmeth morals-spreadplot-supervisor-proto :get-added-var (plot)
  (let* ((mod (send self :model))
         (model (send mod :morals-model))
         (y (send model :y))
         (labels (send mod :labels))
;fwy (datamat (send mod :data-matrix)) replaced this line with next 10/6/96
         (datamat (send model :x))
         (nobs (send mod :nobs))
         (num (iseq (select (array-dimensions datamat) 1)))
         (iv (select (send mod :variables) (send mod :iv)))
         (dv2 (select (send mod :variables) (send mod :dv)))
         (dv (if (listp dv2) (select dv2 0) dv2))
         (text (send text-item-proto :new "Choose Added Variable"))
         (var-toggle (send choice-item-proto :new iv :value (send plot :x)))
         (ok (send modal-button-proto :new "OK" :action
             #'(lambda ()
                 (let* (
                        (dialog (send ok :dialog))
                        (value (send var-toggle :value))
                        (x (combine (select datamat (iseq nobs) value)))
;fwy removed this line (num (remove (send mod :dv) num)) 10/6/96
                        (num (remove value num))
                        (otherxs (select datamat (iseq nobs) num))

                        (yx (regression-model otherxs y :print nil))
                        (xx (regression-model otherxs x :print nil))
                        )
                   (send plot :x value)
                   (send plot :clear-points :draw nil)
                   (send plot :add-points (send xx :residuals)
                         (send yx :residuals) :point-labels labels :draw nil)
                   (send plot :variable-label '(0 1) (list (strcat (select 
                        (send mod :variables) (select (send mod :iv) value))
                             "|Other Vars") (strcat dv "|Other Vars")) 
                         )
                   (send plot :adjust-to-data)
                   (send dialog :modal-dialog-return t)))))
         (cancel (send modal-button-proto :new "Cancel"
                       :action 
                       #'(lambda ()
                           (let ((dialog (send cancel :dialog)))
                             (send dialog :modal-dialog-return nil)))))  
         (var-dialog (send modal-dialog-proto :new
                             (list text var-toggle (list ok cancel))))
         )
  (send var-dialog :modal-dialog)
))
 
 

(defmeth morals-model-object-proto :vif ()
  (let* ((iv (select (send self :variables) (send self :iv)))
         (i 0)
         (mod (send self :morals-model))
         (nobs (send self :nobs))
         (vif nil)
         (vif-list nil)
         )
  (dotimes (i (length (send self :iv)))
           (let* ((vif nil)) 
             (setf vif (/ 1 (- 1 
                (send (regression-model (select (send mod :x)
                (iseq nobs) (remove i (iseq (length (send self :iv)))))
                            (combine (select (send mod :x) (iseq nobs)
                            (select (iseq (length (send self :iv))) i)))
                                        :print nil)
                      :r-squared))))
             (if (= i 0) (setf vif-list vif) (setf vif-list (combine vif-list vif)))
             ))
(send self :vif-list vif-list)))




(defmeth morals-model-object-proto :dffits ()
  (let* ((dffits nil)
         (model nil))
    (if (equalp (send self :method) "Robust") (setf model (send self :robust-model)) (setf model (send self :morals-model)))
    (setf dffits (* (sqrt (/ (send model :leverages)
                             (- 1 (send model :leverages))))
                    (send model :externally-studentized-residuals)))
    dffits))


(defun correlation (x y)
  (let* ((corr nil))
  (setf corr (/ (/ (sum (* (- x (mean x)) (- y (mean y))))
       (- (length x) 1))
       (* (sqrt (/ (sum (* (- x (mean x)) (- x (mean x)))) (- (length x) 1)))
          (sqrt (/ (sum (* (- y (mean y)) (- y (mean y)))) (- (length y) 1))))))
  corr))


(defmeth morals-model-object-proto :autocorr () 
  (let* ((autocorr nil)
         (model nil))
    (if (equalp (send self :method) "Robust") (setf model (send self :robust-model)) (setf model (send self :morals-model)))
    (setf autocorr 
          (correlation (select (send model :raw-residuals) 
                         (iseq (1- (send self :nobs))))
                       (select (send model :raw-residuals)
                         (+ 1 (iseq (1- (send self :nobs)))))))
    autocorr))




